<script lang="ts">
  import type { PlayerId, State } from "../../server";
  import { createActionDispatcher } from "../util/createActionDispatcher";

  const dispatchAction = createActionDispatcher();

  export let state: State;

  let selectedPlayer: PlayerId | null = null;
</script>

<section>
  <h3>Discard a player's hand.</h3>

  <ul>
    {#each state.players as player (player.id)}
      <li>
        <label
          for="discard-target-{player.id}"
          class:disabled={player.hand.length === 0}
        >
          {#if player.protected}
            <span class="emoji">🛡</span>
          {:else}
            <input
              type="radio"
              name="discard-target"
              id="discard-target-{player.id}"
              disabled={player.hand.length === 0}
              bind:group={selectedPlayer}
              value={player.id}
            />
          {/if}
          <gs6-user playerid={player.id} />
        </label>
      </li>
    {/each}
  </ul>

  <button
    class="primary"
    disabled={selectedPlayer === null}
    on:click={() => {
      if (selectedPlayer !== null) {
        dispatchAction({ kind: "Discard", target: selectedPlayer });
      }
    }}
  >
    Discard!
  </button>
</section>

<style>
  section {
    display: flex;
    flex-direction: column;
    align-items: center;
  }

  li {
    margin-top: 0.25em;
    margin-bottom: 0.25em;
    white-space: nowrap;
  }

  .disabled {
    filter: grayscale(0.9) opacity(0.5);
  }
</style>
